hakyll-4.13.4.0: A static website compiler library

Safe Haskell | None
Language | Haskell2010

Hakyll.Web.Paginate

Synopsis

- type PageNumber = Int
- data Paginate = Paginate {
  - paginateMap :: Map PageNumber [Identifier]
  - paginateMakeId :: PageNumber -> Identifier
  - paginateDependency :: Dependency
  }
- buildPaginateWith :: MonadMetadata m => ([Identifier] -> m [[Identifier]]) -> Pattern -> (PageNumber -> Identifier) -> m Paginate
- paginateEvery :: Int -> [a] -> [[a]]
- paginateRules :: Paginate -> (PageNumber -> Pattern -> Rules ()) -> Rules ()
- paginateContext :: Paginate -> PageNumber -> Context a

# Documentation

type PageNumber = Int Source #

data Paginate Source #

Data about paginators

Constructors

Paginate |

Fields

- paginateMap :: Map PageNumber [Identifier]
- paginateMakeId :: PageNumber -> Identifier
- paginateDependency :: Dependency

buildPaginateWith Source #

Arguments

:: MonadMetadata m |
=> ([Identifier] -> m [[Identifier]]) | Group items into pages
-> Pattern | Select items to paginate
-> (PageNumber -> Identifier) | Identifiers for the pages
-> m Paginate |

paginateEvery :: Int -> [a] -> [[a]] Source #

paginateRules :: Paginate -> (PageNumber -> Pattern -> Rules ()) -> Rules () Source #

paginateContext :: Paginate -> PageNumber -> Context a Source #

A default paginate context which provides the following keys:

-     firstPageNum

-     firstPageUrl

-     previousPageNum

-     previousPageUrl

-     nextPageNum

-     nextPageUrl

-     lastPageNum

-     lastPageUrl

-     currentPageNum

-     currentPageUrl

-     numPages

-     allPages